﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using VRage.ModAPI;
using Sandbox.ModAPI;
using VRage.Game;
using VRage.Game.Components;
using VRageMath;
using VRage.Game.ModAPI;
using Sandbox.Definitions;
using System.Text.RegularExpressions;
using UIFun.Messages;
using UIFun.Messagesv2;
using VRage;
using System.Collections.Concurrent;
using Sandbox.Game;

namespace UIFun
{
	public class FontTexture
	{
		int heartbeatsend = 0;
        public static FontTexture instance;

		public enum TextOrientation : byte
		{
			ltr = 1,
			center = 2,
			rtl = 3
		}
		public struct FontMatrix
		{
			public int ox;
			public int oy;
			public int ex;
			public int ey;
			public string material;
		}
		public Dictionary<char, FontMatrix> FontDict = new Dictionary<char, FontMatrix>();
		private ConcurrentDictionary<ModMessageBase, long> ModMessageDictionary = new ConcurrentDictionary<ModMessageBase, long>();
		Dictionary<long, Dictionary<long, MessageBase>> MessageDict = new Dictionary<long, Dictionary<long, MessageBase>>();
		private readonly ushort HUDAPI_ADVMSG = 54019;
		private readonly ushort HUDAPI_MESSAGE = 54020;
		private readonly ushort HUDAPI_RECEIVE = 54021;
		//private readonly long TEXTAPIMODID = 758597413;
		private const long REGISTRATIONID = 573804956;
		static bool m_HudHidden = false;
		public static bool hudHidden 
		{
			get
			{
				return m_HudHidden;
			}
			set
			{
				m_HudHidden = value;
			}

		}

		//call in init only
		public FontTexture()
		{
			FontDict.Clear();
			instance = this;
			//init
			#region CharacterMap

			TryAddChar(' ', 0,0		,15,45, "0020");
			TryAddChar('!', 15,0	,24,45,	"0021");
			TryAddChar('"', 39,0	,25,45,	"0022");
			TryAddChar('#', 64,0	,35,45,	"0023");
			TryAddChar('$', 99,0	,36,45,	"0024");
			TryAddChar('%', 135,0 	,39,45,	"0025");
			TryAddChar('&', 174,0 	,35,45,	"0026");
			TryAddChar('\'', 209,0 	,22,45,	"0027");
			TryAddChar('(', 231,0 	,24,45,	"0028");
			TryAddChar(')', 255,0 	,24,45,	"0029");
			TryAddChar('*', 279,0 	,26,45,	"002a");
			TryAddChar('+', 305,0 	,34,45,	"002b");
			TryAddChar(',', 339,0 	,25,45,	"002c");
			TryAddChar('-', 364,0 	,25,45,	"002d");
			TryAddChar('.', 389,0 	,25,45,	"002e");
			TryAddChar('/', 414,0 	,30,45,	"002f");
			TryAddChar('0', 444,0 	,35,45,	"0030");
			TryAddChar('1', 479,0 	,24,45,	"0031");
			TryAddChar('2', 503,0 	,34,45,	"0032");
			TryAddChar('3', 537,0 	,33,45,	"0033");
			TryAddChar('4', 570,0 	,34,45,	"0034");
			TryAddChar('5', 604,0 	,35,45,	"0035");
			TryAddChar('6', 639,0 	,35,45,	"0036");
			TryAddChar('7', 674,0 	,31,45,	"0037");
			TryAddChar('8', 705,0 	,35,45,	"0038");
			TryAddChar('9', 740,0 	,35,45,	"0039");
			TryAddChar(':', 775,0 	,25,45,	"003a");
			TryAddChar(';', 800,0 	,25,45,	"003b");
			TryAddChar('<', 825,0 	,34,45,	"003c");
			TryAddChar('=', 859,0 	,34,45,	"003d");
			TryAddChar('>', 893,0 	,34,45,	"003e");
			TryAddChar('?', 927,0 	,31,45,	"003f");
			TryAddChar('@', 958,0 	,40,45,	"0040");
			TryAddChar('A', 0,45  	,37,45,	"0041");
			TryAddChar('B', 37,45 	,37,45,	"0042");
			TryAddChar('C', 74,45 	,35,45,	"0043");
			TryAddChar('D', 109,45	,37,45,	"0044");
			TryAddChar('E', 146,45	,34,45,	"0045");
			TryAddChar('F', 180,45	,32,45,	"0046");
			TryAddChar('G', 212,45	,36,45,	"0047");
			TryAddChar('H', 248,45	,35,45,	"0048");
			TryAddChar('I', 283,45	,24,45,	"0049");
			TryAddChar('J', 307,45	,31,45,	"004a");
			TryAddChar('K', 338,45	,33,45,	"004b");
			TryAddChar('L', 371,45	,30,45,	"004c");
			TryAddChar('M', 401,45	,42,45,	"004d");
			TryAddChar('N', 443,45	,37,45,	"004e");
			TryAddChar('O', 480,45	,37,45,	"004f");
			TryAddChar('P', 517,45	,35,45,	"0050");
			TryAddChar('Q', 552,45	,37,45,	"0051");
			TryAddChar('R', 589,45	,37,45,	"0052");
			TryAddChar('S', 626,45	,37,45,	"0053");
			TryAddChar('T', 663,45	,32,45,	"0054");
			TryAddChar('U', 695,45	,36,45,	"0055");
			TryAddChar('V', 731,45	,35,45,	"0056");
			TryAddChar('W', 766,45	,47,45,	"0057");
			TryAddChar('X', 813,45	,35,45,	"0058");
			TryAddChar('Y', 848,45	,36,45,	"0059");
			TryAddChar('Z', 884,45	,35,45,	"005a");
			TryAddChar('[', 919,45	,25,45,	"005b");
			TryAddChar('\\', 944,45	,28,45,	"005c");
			TryAddChar(']', 972,45	,25,45,	"005d");
			TryAddChar('^', 0,90  	,34,45,	"005e");
			TryAddChar('_', 34,90 	,31,45,	"005f");
			TryAddChar('`', 65,90 	,23,45,	"0060");
			TryAddChar('a', 88,90 	,33,45,	"0061");
			TryAddChar('b', 121,90	,33,45,	"0062");
			TryAddChar('c', 154,90	,32,45,	"0063");
			TryAddChar('d', 186,90	,33,45,	"0064");
			TryAddChar('e', 219,90	,33,45,	"0065");
			TryAddChar('f', 252,90	,24,45,	"0066");
			TryAddChar('g', 276,90	,33,45,	"0067");
			TryAddChar('h', 309,90	,33,45,	"0068");
			TryAddChar('i', 342,90	,23,45,	"0069");
			TryAddChar('j', 365,90	,23,45,	"006a");
			TryAddChar('k', 388,90	,32,45,	"006b");
			TryAddChar('l', 420,90	,23,45,	"006c");
			TryAddChar('m', 443,90	,42,45,	"006d");
			TryAddChar('n', 485,90	,33,45,	"006e");
			TryAddChar('o', 518,90	,33,45,	"006f");
			TryAddChar('p', 551,90	,33,45,	"0070");
			TryAddChar('q', 584,90	,33,45,	"0071");
			TryAddChar('r', 617,90	,25,45,	"0072");
			TryAddChar('s', 642,90	,33,45,	"0073");
			TryAddChar('t', 675,90	,25,45,	"0074");
			TryAddChar('u', 700,90	,33,45,	"0075");
			TryAddChar('v', 733,90	,30,45,	"0076");
			TryAddChar('w', 763,90	,42,45,	"0077");
			TryAddChar('x', 805,90	,31,45,	"0078");
			TryAddChar('y', 836,90	,33,45,	"0079");
			TryAddChar('z', 869,90	,31,45,	"007a");
			TryAddChar('{', 900,90	,25,45,	"007b");
			TryAddChar('|', 925,90	,22,45,	"007c");
			TryAddChar('}', 947,90	,25,45,	"007d");
			TryAddChar('~', 972,90	,34,45,	"007e");
			TryAddChar('¡', 23,135	,24,45,	"00a1");
			TryAddChar('¢', 47,135	,32,45,	"00a2");
			TryAddChar('£', 79,135	,33,45,	"00a3");
			TryAddChar('¤', 112,135	,35,45,	"00a4");
			TryAddChar('¥', 147,135	,35,45,	"00a5");
			TryAddChar('¦', 182,135	,22,45,	"00a6");
			TryAddChar('§', 204,135	,36,45,	"00a7");
			TryAddChar('¨', 240,135	,23,45,	"00a8");
			TryAddChar('©', 263,135	,40,45,	"00a9");
			TryAddChar('ª', 303,135	,26,45,	"00aa");
			TryAddChar('«', 329,135	,30,45,	"00ab");
			TryAddChar('¬', 359,135	,34,45,	"00ac");
			TryAddChar('®', 407,135	,40,45,	"00ae");
			TryAddChar('¯', 447,135	,23,45,	"00af");
			TryAddChar('°', 470,135	,27,45,	"00b0");
			TryAddChar('±', 497,135	,34,45,	"00b1");
			TryAddChar('²', 531,135	,27,45,	"00b2");
			TryAddChar('³', 558,135	,27,45,	"00b3");
			TryAddChar('´', 585,135	,23,45,	"00b4");
			TryAddChar('µ', 608,135	,33,45,	"00b5");
			TryAddChar('¶', 641,135	,34,45,	"00b6");
			TryAddChar('·', 675,135	,25,45,	"00b7");
			TryAddChar('¸', 700,135	,23,45,	"00b8");
			TryAddChar('¹', 723,135	,27,45,	"00b9");
			TryAddChar('º', 750,135	,26,45,	"00ba");
			TryAddChar('»', 776,135	,30,45,	"00bb");
			TryAddChar('¼', 806,135	,43,45,	"00bc");
			TryAddChar('½', 849,135	,45,45,	"00bd");
			TryAddChar('¾', 894,135	,43,45,	"00be");
			TryAddChar('¿', 937,135	,31,45,	"00bf");
			TryAddChar('À', 968,135	,37,45,	"00c0");
			TryAddChar('Á', 0,180  	,37,45,	"00c1");
			TryAddChar('Â', 37,180 	,37,45,	"00c2");
			TryAddChar('Ã', 74,180 	,37,45,	"00c3");
			TryAddChar('Ä', 111,180	,37,45,	"00c4");
			TryAddChar('Å', 148,180	,37,45,	"00c5");
			TryAddChar('Æ', 185,180	,47,45,	"00c6");
			TryAddChar('Ç', 232,180	,35,45,	"00c7");
			TryAddChar('È', 267,180	,34,45,	"00c8");
			TryAddChar('É', 301,180	,34,45,	"00c9");
			TryAddChar('Ê', 335,180	,34,45,	"00ca");
			TryAddChar('Ë', 369,180	,34,45,	"00cb");
			TryAddChar('Ì', 403,180	,24,45,	"00cc");
			TryAddChar('Í', 427,180	,24,45,	"00cd");
			TryAddChar('Î', 451,180	,24,45,	"00ce");
			TryAddChar('Ï', 475,180	,24,45,	"00cf");
			TryAddChar('Ð', 499,180	,37,45,	"00d0");
			TryAddChar('Ñ', 536,180	,37,45,	"00d1");
			TryAddChar('Ò', 573,180	,37,45,	"00d2");
			TryAddChar('Ó', 610,180	,37,45,	"00d3");
			TryAddChar('Ô', 647,180	,37,45,	"00d4");
			TryAddChar('Õ', 684,180	,37,45,	"00d5");
			TryAddChar('Ö', 721,180	,37,45,	"00d6");
			TryAddChar('×', 758,180	,34,45,	"00d7");
			TryAddChar('Ø', 792,180	,37,45,	"00d8");
			TryAddChar('Ù', 829,180	,36,45,	"00d9");
			TryAddChar('Ú', 865,180	,36,45,	"00da");
			TryAddChar('Û', 901,180	,36,45,	"00db");
			TryAddChar('Ü', 937,180	,36,45,	"00dc");
			TryAddChar('Ý', 973,180	,33,45,	"00dd");
			TryAddChar('Þ', 0,225  	,35,45,	"00de");
			TryAddChar('ß', 35,225 	,34,45,	"00df");
			TryAddChar('à', 69,225 	,33,45,	"00e0");
			TryAddChar('á', 102,225	,33,45,	"00e1");
			TryAddChar('â', 135,225	,33,45,	"00e2");
			TryAddChar('ã', 168,225	,33,45,	"00e3");
			TryAddChar('ä', 201,225	,33,45,	"00e4");
			TryAddChar('å', 234,225	,33,45,	"00e5");
			TryAddChar('æ', 267,225	,44,45,	"00e6");
			TryAddChar('ç', 311,225	,32,45,	"00e7");
			TryAddChar('è', 343,225	,33,45,	"00e8");
			TryAddChar('é', 376,225	,33,45,	"00e9");
			TryAddChar('ê', 409,225	,33,45,	"00ea");
			TryAddChar('ë', 442,225	,33,45,	"00eb");
			TryAddChar('ì', 475,225	,23,45,	"00ec");
			TryAddChar('í', 498,225	,23,45,	"00ed");
			TryAddChar('î', 521,225	,23,45,	"00ee");
			TryAddChar('ï', 544,225	,23,45,	"00ef");
			TryAddChar('ð', 567,225	,33,45,	"00f0");
			TryAddChar('ñ', 600,225	,33,45,	"00f1");
			TryAddChar('ò', 633,225	,33,45,	"00f2");
			TryAddChar('ó', 666,225	,33,45,	"00f3");
			TryAddChar('ô', 699,225	,33,45,	"00f4");
			TryAddChar('õ', 732,225	,33,45,	"00f5");
			TryAddChar('ö', 765,225	,33,45,	"00f6");
			TryAddChar('÷', 798,225	,34,45,	"00f7");
			TryAddChar('ø', 832,225	,33,45,	"00f8");
			TryAddChar('ù', 865,225	,33,45,	"00f9");
			TryAddChar('ú', 898,225	,33,45,	"00fa");
			TryAddChar('û', 931,225	,33,45,	"00fb");
			TryAddChar('ü', 964,225	,33,45,	"00fc");
			TryAddChar('ý', 0,270 	,33,45,	"00fd");
			TryAddChar('þ', 33,270 	,33,45,	"00fe");
			TryAddChar('ÿ', 66,270 	,33,45,	"00ff");
			TryAddChar('Ā', 99,270 	,35,45,	"0100");
			TryAddChar('ā', 134,270	,33,45,	"0101");
			TryAddChar('Ă', 167,270	,37,45,	"0102");
			TryAddChar('ă', 204,270	,33,45,	"0103");
			TryAddChar('Ą', 237,270	,37,45,	"0104");
			TryAddChar('ą', 274,270	,33,45,	"0105");
			TryAddChar('Ć', 307,270	,35,45,	"0106");
			TryAddChar('ć', 342,270	,32,45,	"0107");
			TryAddChar('Ĉ', 374,270	,35,45,	"0108");
			TryAddChar('ĉ', 409,270	,32,45,	"0109");
			TryAddChar('Ċ', 441,270	,35,45,	"010a");
			TryAddChar('ċ', 476,270	,32,45,	"010b");
			TryAddChar('Č', 508,270	,35,45,	"010c");
			TryAddChar('č', 543,270	,32,45,	"010d");
			TryAddChar('Ď', 575,270	,37,45,	"010e");
			TryAddChar('ď', 612,270	,33,45,	"010f");
			TryAddChar('Đ', 645,270	,37,45,	"0110");
			TryAddChar('đ', 682,270	,33,45,	"0111");
			TryAddChar('Ē', 715,270	,34,45,	"0112");
			TryAddChar('ē', 749,270	,33,45,	"0113");
			TryAddChar('Ĕ', 782,270	,34,45,	"0114");
			TryAddChar('ĕ', 816,270	,33,45,	"0115");
			TryAddChar('Ė', 849,270	,34,45,	"0116");
			TryAddChar('ė', 883,270	,33,45,	"0117");
			TryAddChar('Ę', 916,270	,34,45,	"0118");
			TryAddChar('ę', 950,270	,33,45,	"0119");
			TryAddChar('Ě', 983,270	,34,45,	"011a");
			TryAddChar('ě', 0,315 	,33,45,	"011b");
			TryAddChar('Ĝ', 33,315  ,36,45,	"011c");
			TryAddChar('ĝ', 69,315 	,33,45,	"011d");
			TryAddChar('Ğ', 102,315	,36,45,	"011e");
			TryAddChar('ğ', 138,315	,33,45,	"011f");
			TryAddChar('Ġ', 171,315	,36,45,	"0120");
			TryAddChar('ġ', 207,315	,33,45,	"0121");
			TryAddChar('Ģ', 240,315	,36,45,	"0122");
			TryAddChar('ģ', 276,315	,33,45,	"0123");
			TryAddChar('Ĥ', 309,315	,35,45,	"0124");
			TryAddChar('ĥ', 344,315	,33,45,	"0125");
			TryAddChar('Ħ', 377,315	,35,45,	"0126");
			TryAddChar('ħ', 412,315	,33,45,	"0127");
			TryAddChar('Ĩ', 445,315	,24,45,	"0128");
			TryAddChar('ĩ', 469,315	,23,45,	"0129");
			TryAddChar('Ī', 492,315	,24,45,	"012a");
			TryAddChar('ī', 516,315	,23,45,	"012b");
			TryAddChar('Į', 539,315	,24,45,	"012e");
			TryAddChar('į', 563,315	,23,45,	"012f");
			TryAddChar('İ', 586,315	,24,45,	"0130");
			TryAddChar('ı', 610,315	,23,45,	"0131");
			TryAddChar('Ĳ', 633,315	,40,45,	"0132");
			TryAddChar('ĳ', 673,315	,29,45,	"0133");
			TryAddChar('Ĵ', 702,315	,31,45,	"0134");
			TryAddChar('ĵ', 733,315	,23,45,	"0135");
			TryAddChar('Ķ', 756,315	,33,45,	"0136");
			TryAddChar('ķ', 789,315	,32,45,	"0137");
			TryAddChar('Ĺ', 821,315	,30,45,	"0139");
			TryAddChar('ĺ', 851,315	,23,45,	"013a");
			TryAddChar('Ļ', 874,315	,30,45,	"013b");
			TryAddChar('ļ', 904,315	,23,45,	"013c");
			TryAddChar('Ľ', 927,315	,30,45,	"013d");
			TryAddChar('ľ', 957,315	,23,45,	"013e");
			TryAddChar('Ŀ', 980,315	,30,45,	"013f");
			TryAddChar('ŀ', 0,360 	,26,45,	"0140");
			TryAddChar('Ł', 26,360 	,30,45,	"0141");
			TryAddChar('ł', 56,360 	,23,45,	"0142");
			TryAddChar('Ń', 79,360 	,37,45,	"0143");
			TryAddChar('ń', 116,360	,33,45,	"0144");
			TryAddChar('Ņ', 149,360	,37,45,	"0145");
			TryAddChar('ņ', 186,360	,33,45,	"0146");
			TryAddChar('Ň', 219,360	,37,45,	"0147");
			TryAddChar('ň', 256,360	,33,45,	"0148");
			TryAddChar('ŉ', 289,360	,33,45,	"0149");
			TryAddChar('Ō', 322,360	,37,45,	"014c");
			TryAddChar('ō', 359,360	,33,45,	"014d");
			TryAddChar('Ŏ', 392,360	,37,45,	"014e");
			TryAddChar('ŏ', 429,360	,33,45,	"014f");
			TryAddChar('Ő', 462,360	,37,45,	"0150");
			TryAddChar('ő', 499,360	,33,45,	"0151");
			TryAddChar('Œ', 532,360	,47,45,	"0152");
			TryAddChar('œ', 579,360	,44,45,	"0153");
			TryAddChar('Ŕ', 623,360	,37,45,	"0154");
			TryAddChar('ŕ', 660,360	,25,45,	"0155");
			TryAddChar('Ŗ', 685,360	,37,45,	"0156");
			TryAddChar('ŗ', 722,360	,25,45,	"0157");
			TryAddChar('Ř', 747,360	,37,45,	"0158");
			TryAddChar('ř', 784,360	,25,45,	"0159");
			TryAddChar('Ś', 809,360	,37,45,	"015a");
			TryAddChar('ś', 846,360	,33,45,	"015b");
			TryAddChar('Ŝ', 879,360	,37,45,	"015c");
			TryAddChar('ŝ', 916,360	,33,45,	"015d");
			TryAddChar('Ş', 949,360	,37,45,	"015e");
			TryAddChar('ş', 986,360	,33,45,	"015f");
			TryAddChar('Š', 0,405 	,37,45,	"0160");
			TryAddChar('š', 37,405 	,33,45,	"0161");
			TryAddChar('Ţ', 70,405  ,32,45,	"0162");
			TryAddChar('ţ', 102,405	,25,45,	"0163");
			TryAddChar('Ť', 127,405	,32,45,	"0164");
			TryAddChar('ť', 159,405	,25,45,	"0165");
			TryAddChar('Ŧ', 184,405	,32,45,	"0166");
			TryAddChar('ŧ', 216,405	,25,45,	"0167");
			TryAddChar('Ũ', 241,405	,36,45,	"0168");
			TryAddChar('ũ', 277,405	,33,45,	"0169");
			TryAddChar('Ū', 310,405	,36,45,	"016a");
			TryAddChar('ū', 346,405	,33,45,	"016b");
			TryAddChar('Ŭ', 379,405	,36,45,	"016c");
			TryAddChar('ŭ', 415,405	,33,45,	"016d");
			TryAddChar('Ů', 448,405	,36,45,	"016e");
			TryAddChar('ů', 484,405	,33,45,	"016f");
			TryAddChar('Ű', 517,405	,36,45,	"0170");
			TryAddChar('ű', 553,405	,33,45,	"0171");
			TryAddChar('Ų', 586,405	,36,45,	"0172");
			TryAddChar('ų', 622,405	,33,45,	"0173");
			TryAddChar('Ŵ', 655,405	,47,45,	"0174");
			TryAddChar('ŵ', 702,405	,42,45,	"0175");
			TryAddChar('Ŷ', 744,405	,33,45,	"0176");
			TryAddChar('ŷ', 777,405	,33,45,	"0177");
			TryAddChar('Ÿ', 810,405	,33,45,	"0178");
			TryAddChar('Ź', 843,405	,35,45,	"0179");
			TryAddChar('ź', 878,405	,31,45,	"017a");
			TryAddChar('Ż', 909,405	,35,45,	"017b");
			TryAddChar('ż', 944,405	,31,45,	"017c");
			TryAddChar('Ž', 975,405	,35,45,	"017d");
			TryAddChar('ž', 0,450 	,31,45,	"017e");
			TryAddChar('ƒ', 31,450 	,35,45,	"0192");
			TryAddChar('Ș', 66,450 	,37,45,	"0218");
			TryAddChar('ș', 103,450	,33,45,	"0219");
			TryAddChar('Ț', 136,450	,32,45,	"021a");
			TryAddChar('ț', 168,450	,25,45,	"021b");
			TryAddChar('ˆ', 193,450	,23,45,	"02c6");
			TryAddChar('ˇ', 216,450	,23,45,	"02c7");
			TryAddChar('ˉ', 239,450	,22,45,	"02c9");
			TryAddChar('˘', 261,450	,23,45,	"02d8");
			TryAddChar('˙', 284,450	,23,45,	"02d9");
			TryAddChar('˚', 307,450	,23,45,	"02da");
			TryAddChar('˛', 330,450	,23,45,	"02db");
			TryAddChar('˜', 353,450	,23,45,	"02dc");
			TryAddChar('˝', 376,450	,23,45,	"02dd");
			TryAddChar('Ё', 399,450	,34,45,	"0401");
			TryAddChar('Ѓ', 433,450	,32,45,	"0403");
			TryAddChar('Є', 465,450	,34,45,	"0404");
			TryAddChar('Ѕ', 499,450	,37,45,	"0405");
			TryAddChar('І', 536,450	,24,45,	"0406");
			TryAddChar('Ї', 560,450	,24,45,	"0407");
			TryAddChar('Ј', 584,450	,31,45,	"0408");
			TryAddChar('Љ', 615,450	,43,45,	"0409");
			TryAddChar('Њ', 658,450	,37,45,	"040a");
			TryAddChar('Ќ', 695,450	,34,45,	"040c");
			TryAddChar('Ў', 729,450	,32,45,	"040e");
			TryAddChar('Џ', 761,450	,33,45,	"040f");
			TryAddChar('А', 794,450	,35,45,	"0410");
			TryAddChar('Б', 829,450	,35,45,	"0411");
			TryAddChar('В', 864,450	,35,45,	"0412");
			TryAddChar('Г', 899,450	,30,45,	"0413");
			TryAddChar('Д', 929,450	,35,45,	"0414");
			TryAddChar('Е', 964,450	,34,45,	"0415");
			TryAddChar('Ж', 0,495 	,37,45,	"0416");
			TryAddChar('З', 37,495 	,33,45,	"0417");
			TryAddChar('И', 70,495 	,35,45,	"0418");
			TryAddChar('Й', 105,495	,34,45,	"0419");
			TryAddChar('К', 139,495	,33,45,	"041a");
			TryAddChar('Л', 172,495	,33,45,	"041b");
			TryAddChar('М', 205,495	,42,45,	"041c");
			TryAddChar('Н', 247,495	,33,45,	"041d");
			TryAddChar('О', 280,495	,35,45,	"041e");
			TryAddChar('П', 315,495	,34,45,	"041f");
			TryAddChar('Р', 349,495	,34,45,	"0420");
			TryAddChar('С', 383,495	,35,45,	"0421");
			TryAddChar('Т', 418,495	,35,45,	"0422");
			TryAddChar('У', 453,495	,35,45,	"0423");
			TryAddChar('Ф', 488,495	,36,45,	"0424");
			TryAddChar('Х', 524,495	,35,45,	"0425");
			TryAddChar('Ц', 559,495	,36,45,	"0426");
			TryAddChar('Ч', 595,495	,32,45,	"0427");
			TryAddChar('Ш', 627,495	,42,45,	"0428");
			TryAddChar('Щ', 669,495	,45,45,	"0429");
			TryAddChar('Ъ', 714,495	,35,45,	"042a");
			TryAddChar('Ы', 749,495	,40,45,	"042b");
			TryAddChar('Ь', 789,495	,34,45,	"042c");
			TryAddChar('Э', 823,495	,34,45,	"042d");
			TryAddChar('Ю', 857,495	,42,45,	"042e");
			TryAddChar('Я', 899,495	,35,45,	"042f");
			TryAddChar('а', 934,495	,32,45,	"0430");
			TryAddChar('б', 966,495	,33,45,	"0431");
			TryAddChar('в', 0,540 	,31,45,	"0432");
			TryAddChar('г', 31,540 	,30,45,	"0433");
			TryAddChar('д', 61,540 	,33,45,	"0434");
			TryAddChar('е', 94,540 	,33,45,	"0435");
			TryAddChar('ж', 127,540	,36,45,	"0436");
			TryAddChar('з', 163,540	,30,45,	"0437");
			TryAddChar('и', 193,540	,32,45,	"0438");
			TryAddChar('й', 225,540	,32,45,	"0439");
			TryAddChar('к', 257,540	,32,45,	"043a");
			TryAddChar('л', 289,540	,30,45,	"043b");
			TryAddChar('м', 319,540	,41,45,	"043c");
			TryAddChar('н', 360,540	,31,45,	"043d");
			TryAddChar('о', 391,540	,32,45,	"043e");
			TryAddChar('п', 423,540	,32,45,	"043f");
			TryAddChar('р', 455,540	,32,45,	"0440");
			TryAddChar('с', 487,540	,32,45,	"0441");
			TryAddChar('т', 519,540	,30,45,	"0442");
			TryAddChar('у', 549,540	,33,45,	"0443");
			TryAddChar('ф', 582,540	,37,45,	"0444");
			TryAddChar('х', 619,540	,31,45,	"0445");
			TryAddChar('ц', 650,540	,33,45,	"0446");
			TryAddChar('ч', 683,540	,31,45,	"0447");
			TryAddChar('ш', 714,540	,41,45,	"0448");
			TryAddChar('щ', 755,540	,42,45,	"0449");
			TryAddChar('ъ', 797,540	,31,45,	"044a");
			TryAddChar('ы', 828,540	,36,45,	"044b");
			TryAddChar('ь', 864,540	,31,45,	"044c");
			TryAddChar('э', 895,540	,30,45,	"044d");
			TryAddChar('ю', 925,540	,39,45,	"044e");
			TryAddChar('я', 964,540	,32,45,	"044f");
			TryAddChar('ё', 0,585 	,33,45,	"0451");
			TryAddChar('ђ', 33,585 	,33,45,	"0452");
			TryAddChar('ѓ', 66,585 	,31,45,	"0453");
			TryAddChar('є', 97,585 	,30,45,	"0454");
			TryAddChar('ѕ', 127,585	,32,45,	"0455");
			TryAddChar('і', 159,585	,23,45,	"0456");
			TryAddChar('ї', 182,585	,23,45,	"0457");
			TryAddChar('ј', 205,585	,22,45,	"0458");
			TryAddChar('љ', 227,585	,38,45,	"0459");
			TryAddChar('њ', 265,585	,41,45,	"045a");
			TryAddChar('ћ', 306,585	,33,45,	"045b");
			TryAddChar('ќ', 339,585	,31,45,	"045c");
			TryAddChar('ў', 370,585	,33,45,	"045e");
			TryAddChar('џ', 403,585	,33,45,	"045f");
			TryAddChar('Ґ', 436,585	,30,45,	"0490");
			TryAddChar('ґ', 466,585	,29,45,	"0491");
			TryAddChar('–', 495,585	,30,45,	"2013");
			TryAddChar('—', 525,585	,46,45,	"2014");
			TryAddChar('‘', 571,585	,22,45,	"2018");
			TryAddChar('’', 593,585	,22,45,	"2019");
			TryAddChar('‚', 615,585	,22,45,	"201a");
			TryAddChar('“', 637,585	,27,45,	"201c");
			TryAddChar('”', 664,585	,27,45,	"201d");
			TryAddChar('„', 691,585	,27,45,	"201e");
			TryAddChar('†', 718,585	,36,45,	"2020");
			TryAddChar('‡', 754,585	,36,45,	"2021");
			TryAddChar('•', 790,585	,31,45,	"2022");
			TryAddChar('…', 821,585	,47,45,	"2026");
			TryAddChar('‰', 868,585	,47,45,	"2030");
			TryAddChar('‹', 915,585	,24,45,	"2039");
			TryAddChar('›', 939,585	,24,45,	"203a");
			TryAddChar('€', 963,585	,35,45,	"20ac");
			TryAddChar('™', 0,630	,46,45,	"2122");
			TryAddChar('−', 46,630	,34,45,	"2212");
			TryAddChar('∙', 80,630	,24,45,	"2219");
			TryAddChar('□', 104,630 ,37,45, "25a1");

			//TryAddChar('­',  393,135 ,14,8,	"00ad");
			//TryAddChar(' ', 0,135	,23,45,	"00a0");
			#region old
			/*TryAddChar(' ', 0, 0, 15, 45,"_space");
			
			TryAddChar('!',15,0,24,45);
			TryAddChar('\"',39,0,25,45,"_quote");//10" lsb="-7";
			TryAddChar('#',64,0,35,45);//19" lsb="-7";
			TryAddChar('$',99,0,36,45);//20" lsb="-7";
			TryAddChar('%',135,0,39,45,"_per");//24" lsb="-7";
			TryAddChar('&',174,0,35,45,"_amp");//20" lsb="-7";
			TryAddChar('\'',209,0,22,45);//6" lsb="-7";
			TryAddChar('(',231,0,24,45);//9" lsb="-7";
			TryAddChar(')',255,0,24,45);//9" lsb="-7";
			TryAddChar('*',279,0,26,45,"_star");//11" lsb="-7";
			TryAddChar('+',305,0,34,45);//18" lsb="-7";
			TryAddChar(',',339,0,25,45);//9" lsb="-7";
			TryAddChar('-',364,0,25,45);//10" lsb="-7";/
			TryAddChar('.',389,0,25,45, "_period");//9" lsb="-7";/
			TryAddChar('/',414,0,30,45,"_fslash");//14" lsb="-7";
			TryAddChar('0',444,0,35,45);//19" lsb="-7";/
			TryAddChar('1',479,0,24,45);//9" lsb="-7";
			TryAddChar('2',503,0,34,45);//19" lsb="-7";
			TryAddChar('3',537,0,33,45);//17" lsb="-7";
			TryAddChar('4',570,0,34,45);//19" lsb="-7";
			TryAddChar('5',604,0,35,45);//19" lsb="-7";
			TryAddChar('6',639,0,35,45);//19" lsb="-7";
			TryAddChar('7',674,0,31,45);//16" lsb="-7";
			TryAddChar('8',705,0,35,45);//19" lsb="-7";
			TryAddChar('9',740,0,35,45);//19" lsb="-7";
			TryAddChar(':',775,0,25,45, "_colon");//9" lsb="-7";
			TryAddChar(';',800,0,25,45);//9" lsb="-7";
			TryAddChar('<',825,0,34,45,"_lt");//18" lsb="-7";
			TryAddChar('=',859,0,34,45);//18" lsb="-7";
			TryAddChar('>',893,0,34,45,"_gt");//18" lsb="-7";
			TryAddChar('?',927,0,31,45,"_qm");//16" lsb="-7";
			TryAddChar('@',958,0,40,45);//25" lsb="-7";
			TryAddChar('A',0,45,37,45,"_AA");//21" lsb="-7";
			TryAddChar('B',37,45,37,45,"_BB");//21" lsb="-7";
			TryAddChar('C',74,45,35,45,"_CC");//19" lsb="-7";
			TryAddChar('D',109,45,37,45,"_DD");//21" lsb="-7";
			TryAddChar('E',146,45,34,45,"_EE");//18" lsb="-7";
			TryAddChar('F',180,45,32,45,"_FF");//17" lsb="-7";
			TryAddChar('G',212,45,36,45,"_GG");//20" lsb="-7";
			TryAddChar('H',248,45,35,45,"_HH");//20" lsb="-7";
			TryAddChar('I',283,45,24,45,"_II");//8" lsb="-7";
			TryAddChar('J',307,45,31,45,"_JJ");//16" lsb="-7";
			TryAddChar('K',338,45,33,45,"_KK");//17" lsb="-7";
			TryAddChar('L',371,45,30,45,"_LL");//15" lsb="-7";
			TryAddChar('M',401,45,42,45,"_MM");//26" lsb="-7";
			TryAddChar('N',443,45,37,45,"_NN");//21" lsb="-7";
			TryAddChar('O',480,45,37,45,"_OO");//21" lsb="-7";
			TryAddChar('P',517,45,35,45,"_PP");//20" lsb="-7";
			TryAddChar('Q',552,45,37,45,"_QQ");//21" lsb="-7";
			TryAddChar('R',589,45,37,45,"_RR");//21" lsb="-7";
			TryAddChar('S',626,45,37,45,"_SS");//21" lsb="-7";
			TryAddChar('T',663,45,32,45,"_TT");//17" lsb="-7";
			TryAddChar('U',695,45,36,45,"_UU");//20" lsb="-7";
			TryAddChar('V',731,45,35,45,"_VV");//20" lsb="-7";
			TryAddChar('W',766,45,47,45,"_WW");//31" lsb="-7";
			TryAddChar('X',813,45,35,45,"_XX");//19" lsb="-7";
			TryAddChar('Y',848,45,36,45,"_YY");//20" lsb="-7";
			TryAddChar('Z',884,45,35,45,"_ZZ");//19" lsb="-7";
			TryAddChar('[',919,45,25,45);//9" lsb="-7";
			TryAddChar('\\',944,45,28,45,"_bkslsh");//12" lsb="-7";
			TryAddChar(']',972,45,25,45);//9" lsb="-7";
			TryAddChar('^',0,90,34,45,"_carot");//18" lsb="-7";
			TryAddChar('_',34,90,31,45);//15" lsb="-7";
			TryAddChar('`',65,90,23,45);//8" lsb="-7";
			TryAddChar('a',88,90,33,45);//17" lsb="-7";
			TryAddChar('b',121,90,33,45);//17" lsb="-7";
			TryAddChar('c',154,90,32,45);//16" lsb="-7";
			TryAddChar('d',186,90,33,45);//17" lsb="-7";
			TryAddChar('e',219,90,33,45);//17" lsb="-7";
			TryAddChar('f',252,90,24,45);//9" lsb="-7";
			TryAddChar('g',276,90,33,45);//17" lsb="-7";
			TryAddChar('h',309,90,33,45);//17" lsb="-7";
			TryAddChar('i',342,90,23,45);//8" lsb="-7";
			TryAddChar('j',365,90,23,45);//8" lsb="-7";
			TryAddChar('k',388,90,32,45);//17" lsb="-7";
			TryAddChar('l',420,90,23,45);//8" lsb="-7";
			TryAddChar('m',443,90,42,45);//27" lsb="-7";
			TryAddChar('n',485,90,33,45);//17" lsb="-7";
			TryAddChar('o',518,90,33,45);//17" lsb="-7";
			TryAddChar('p',551,90,33,45);//17" lsb="-7";
			TryAddChar('q',584,90,33,45);//17" lsb="-7";
			TryAddChar('r',617,90,25,45);//10" lsb="-7";
			TryAddChar('s',642,90,33,45);//17" lsb="-7";
			TryAddChar('t',675,90,25,45);//9" lsb="-7";
			TryAddChar('u',700,90,33,45);//17" lsb="-7";
			TryAddChar('v',733,90,30,45);//15" lsb="-7";
			TryAddChar('w',763,90,42,45);//27" lsb="-7";
			TryAddChar('x',805,90,31,45);//15" lsb="-7";
			TryAddChar('y',836,90,33,45);//17" lsb="-7";
			TryAddChar('z',869,90,31,45);//16" lsb="-7";
			TryAddChar('{',900,90,25,45);//9" lsb="-7";
			TryAddChar('|',925,90,22,45, "_pipe");//6" lsb="-7";
			TryAddChar('}',947,90,25,45);//9" lsb="-7";
			TryAddChar('~',972,90,34,45);//18" lsb="-7";
			//TryAddChar(' ',0,135,23,45);//8" lsb="-7";
			//TryAddChar('¡',23,135,24,45);//8" lsb="-7";
			//TryAddChar('¢',47,135,32,45);//16" lsb="-7";
			//TryAddChar('£',79,135,33,45);//17" lsb="-7";
			*/
			#endregion
			#region hide
			/*TryAddChar("¤",112,135,35,45);//19" lsb="-7";
			TryAddChar("¥",147,135,35,45);//19" lsb="-7";
			TryAddChar("¦",182,135,22,45);//6" lsb="-7";
			TryAddChar("§",204,135,36,45);//20" lsb="-7";
			TryAddChar("¨",240,135,23,45);//8" lsb="-7";
			TryAddChar("©",263,135,40,45);//25" lsb="-7";
			TryAddChar("ª",303,135,26,45);//10" lsb="-7";
			TryAddChar("«",329,135,30,45);//15" lsb="-7";
			TryAddChar("¬",359,135,34,45);//18" lsb="-7";
			TryAddChar("­",393,135,14,8);//10" lsb="-7";
			TryAddChar("®",407,135,40,45);//25" lsb="-7";
			TryAddChar("¯",447,135,23,45);//8" lsb="-7";
			TryAddChar("°",470,135,27,45);//12" lsb="-7";
			TryAddChar("±",497,135,34,45);//18" lsb="-7";
			TryAddChar("²",531,135,27,45);//11" lsb="-7";
			TryAddChar("³",558,135,27,45);//11" lsb="-7";
			TryAddChar("´",585,135,23,45);//8" lsb="-7";
			TryAddChar("µ",608,135,33,45);//17" lsb="-7";
			TryAddChar("¶",641,135,34,45);//18" lsb="-7";
			TryAddChar("·",675,135,25,45);//9" lsb="-7";
			TryAddChar("¸",700,135,23,45);//8" lsb="-7";
			TryAddChar("¹",723,135,27,45);//11" lsb="-7";
			TryAddChar("º",750,135,26,45);//10" lsb="-7";
			TryAddChar("»",776,135,30,45);//15" lsb="-7";
			TryAddChar("¼",806,135,43,45);//27" lsb="-7";
			TryAddChar("½",849,135,45,45);//29" lsb="-7";
			TryAddChar("¾",894,135,43,45);//28" lsb="-7";
			TryAddChar("¿",937,135,31,45);//16" lsb="-7";
			TryAddChar("À",968,135,37,45);//21" lsb="-7";
			TryAddChar("Á",0,180,37,45);//21" lsb="-7";
			TryAddChar("Â",37,180,37,45);//21" lsb="-7";
			TryAddChar("Ã",74,180,37,45);//21" lsb="-7";
			TryAddChar("Ä",111,180,37,45);//21" lsb="-7";
			TryAddChar("Å",148,180,37,45);//21" lsb="-7";
			TryAddChar("Æ",185,180,47,45);//31" lsb="-7";
			TryAddChar("Ç",232,180,35,45);//19" lsb="-7";
			TryAddChar("È",267,180,34,45);//18" lsb="-7";
			TryAddChar("É",301,180,34,45);//18" lsb="-7";
			TryAddChar("Ê",335,180,34,45);//18" lsb="-7";
			/*
			TryAddChar("Ë', 00cb, 369,180,34x45);//18" lsb="-7";
			TryAddChar("Ì', 00cc, 403,180,24x45);//8" lsb="-7";
			TryAddChar("Í', 00cd, 427,180,24x45);//8" lsb="-7";
			TryAddChar("Î', 00ce, 451,180,24x45);//8" lsb="-7";
			TryAddChar("Ï', 00cf, 475,180,24x45);//8" lsb="-7";
			TryAddChar("Ð', 00d0, 499,180,37x45);//21" lsb="-7";
			TryAddChar("Ñ', 00d1, 536,180,37x45);//21" lsb="-7";
			TryAddChar("Ò', 00d2, 573,180,37x45);//21" lsb="-7";
			TryAddChar("Ó', 00d3, 610,180,37x45);//21" lsb="-7";
			TryAddChar("Ô', 00d4, 647,180,37x45);//21" lsb="-7";
			TryAddChar("Õ', 00d5, 684,180,37x45);//21" lsb="-7";
			TryAddChar("Ö', 00d6, 721,180,37x45);//21" lsb="-7";
			TryAddChar("×', 00d7, 758,180,34x45);//18" lsb="-7";
			TryAddChar("Ø', 00d8, 792,180,37x45);//21" lsb="-7";
			TryAddChar("Ù', 00d9, 829,180,36x45);//20" lsb="-7";
			TryAddChar("Ú', 00da, 865,180,36x45);//20" lsb="-7";
			TryAddChar("Û', 00db, 901,180,36x45);//20" lsb="-7";
			TryAddChar("Ü', 00dc, 937,180,36x45);//20" lsb="-7";
			TryAddChar("Ý', 00dd, 973,180,33x45);//17" lsb="-7";
			TryAddChar("Þ', 00de, 0,225,35x45);//20" lsb="-7";
			TryAddChar("ß', 00df, 35,225,34x45);//19" lsb="-7";
			TryAddChar("à', 00e0, 69,225,33x45);//17" lsb="-7";
			TryAddChar("á', 00e1, 102,225,33x45);//17" lsb="-7";
			TryAddChar("â', 00e2, 135,225,33x45);//17" lsb="-7";
			TryAddChar("ã', 00e3, 168,225,33x45);//17" lsb="-7";
			TryAddChar("ä', 00e4, 201,225,33x45);//17" lsb="-7";
			TryAddChar("å', 00e5, 234,225,33x45);//17" lsb="-7";
			TryAddChar("æ', 00e6, 267,225,44x45);//28" lsb="-7";
			TryAddChar("ç', 00e7, 311,225,32x45);//16" lsb="-7";
			TryAddChar("è', 00e8, 343,225,33x45);//17" lsb="-7";
			TryAddChar("é', 00e9, 376,225,33x45);//17" lsb="-7";
			TryAddChar("ê', 00ea, 409,225,33x45);//17" lsb="-7";
			TryAddChar("ë', 00eb, 442,225,33x45);//17" lsb="-7";
			TryAddChar("ì', 00ec, 475,225,23x45);//8" lsb="-7";
			TryAddChar("í', 00ed, 498,225,23x45);//8" lsb="-7";
			TryAddChar("î', 00ee, 521,225,23x45);//8" lsb="-7";
			TryAddChar("ï', 00ef, 544,225,23x45);//8" lsb="-7";
			TryAddChar("ð', 00f0, 567,225,33x45);//17" lsb="-7";
			TryAddChar("ñ', 00f1, 600,225,33x45);//17" lsb="-7";
			TryAddChar("ò', 00f2, 633,225,33x45);//17" lsb="-7";
			TryAddChar("ó', 00f3, 666,225,33x45);//17" lsb="-7";
			TryAddChar("ô', 00f4, 699,225,33x45);//17" lsb="-7";
			TryAddChar("õ', 00f5, 732,225,33x45);//17" lsb="-7";
			TryAddChar("ö', 00f6, 765,225,33x45);//17" lsb="-7";
			TryAddChar("÷', 00f7, 798,225,34x45);//18" lsb="-7";
			TryAddChar("ø', 00f8, 832,225,33x45);//17" lsb="-7";
			TryAddChar("ù', 00f9, 865,225,33x45);//17" lsb="-7";
			TryAddChar("ú', 00fa, 898,225,33x45);//17" lsb="-7";
			TryAddChar("û', 00fb, 931,225,33x45);//17" lsb="-7";
			TryAddChar("ü', 00fc, 964,225,33x45);//17" lsb="-7";
			TryAddChar("ý', 00fd, 0,270,33x45);//17" lsb="-7";
			TryAddChar("þ', 00fe, 33,270,33x45);//17" lsb="-7";
			TryAddChar("ÿ', 00ff, 66,270,33x45);//17" lsb="-7";
			TryAddChar("Ā', 0100, 99,270,35x45);//20" lsb="-7";
			TryAddChar("ā', 0101, 134,270,33x45);//17" lsb="-7";
			TryAddChar("Ă', 0102, 167,270,37x45);//21" lsb="-7";
			TryAddChar("ă', 0103, 204,270,33x45);//17" lsb="-7";
			TryAddChar("Ą', 0104, 237,270,37x45);//21" lsb="-7";
			TryAddChar("ą', 0105, 274,270,33x45);//17" lsb="-7";
			TryAddChar("Ć', 0106, 307,270,35x45);//19" lsb="-7";
			TryAddChar("ć', 0107, 342,270,32x45);//16" lsb="-7";
			TryAddChar("Ĉ', 0108, 374,270,35x45);//19" lsb="-7";
			TryAddChar("ĉ', 0109, 409,270,32x45);//16" lsb="-7";
			TryAddChar("Ċ', 010a, 441,270,35x45);//19" lsb="-7";
			TryAddChar("ċ', 010b, 476,270,32x45);//16" lsb="-7";
			TryAddChar("Č', 010c, 508,270,35x45);//19" lsb="-7";
			TryAddChar("č', 010d, 543,270,32x45);//16" lsb="-7";
			TryAddChar("Ď', 010e, 575,270,37x45);//21" lsb="-7";
			TryAddChar("ď', 010f, 612,270,33x45);//17" lsb="-7";
			TryAddChar("Đ', 0110, 645,270,37x45);//21" lsb="-7";
			TryAddChar("đ', 0111, 682,270,33x45);//17" lsb="-7";
			TryAddChar("Ē', 0112, 715,270,34x45);//18" lsb="-7";
			TryAddChar("ē', 0113, 749,270,33x45);//17" lsb="-7";
			TryAddChar("Ĕ', 0114, 782,270,34x45);//18" lsb="-7";
			TryAddChar("ĕ', 0115, 816,270,33x45);//17" lsb="-7";
			TryAddChar("Ė', 0116, 849,270,34x45);//18" lsb="-7";
			TryAddChar("ė', 0117, 883,270,33x45);//17" lsb="-7";
			TryAddChar("Ę', 0118, 916,270,34x45);//18" lsb="-7";
			TryAddChar("ę', 0119, 950,270,33x45);//17" lsb="-7";
			TryAddChar("Ě', 011a, 983,270,34x45);//18" lsb="-7";
			TryAddChar("ě', 011b, 0,315,33x45);//17" lsb="-7";
			TryAddChar("Ĝ', 011c, 33,315,36x45);//20" lsb="-7";
			TryAddChar("ĝ', 011d, 69,315,33x45);//17" lsb="-7";
			TryAddChar("Ğ', 011e, 102,315,36x45);//20" lsb="-7";
			TryAddChar("ğ', 011f, 138,315,33x45);//17" lsb="-7";
			TryAddChar("Ġ', 0120, 171,315,36x45);//20" lsb="-7";
			TryAddChar("ġ', 0121, 207,315,33x45);//17" lsb="-7";
			TryAddChar("Ģ', 0122, 240,315,36x45);//20" lsb="-7";
			TryAddChar("ģ', 0123, 276,315,33x45);//17" lsb="-7";
			TryAddChar("Ĥ', 0124, 309,315,35x45);//20" lsb="-7";
			TryAddChar("ĥ', 0125, 344,315,33x45);//17" lsb="-7";
			TryAddChar("Ħ', 0126, 377,315,35x45);//20" lsb="-7";
			TryAddChar("ħ', 0127, 412,315,33x45);//17" lsb="-7";
			TryAddChar("Ĩ', 0128, 445,315,24x45);//8" lsb="-7";
			TryAddChar("ĩ', 0129, 469,315,23x45);//8" lsb="-7";
			TryAddChar("Ī', 012a, 492,315,24x45);//8" lsb="-7";
			TryAddChar("ī', 012b, 516,315,23x45);//8" lsb="-7";
			TryAddChar("Į', 012e, 539,315,24x45);//8" lsb="-7";
			TryAddChar("į', 012f, 563,315,23x45);//8" lsb="-7";
			TryAddChar("İ', 0130, 586,315,24x45);//8" lsb="-7";
			TryAddChar("ı', 0131, 610,315,23x45);//8" lsb="-7";
			TryAddChar("Ĳ', 0132, 633,315,40x45);//24" lsb="-7";
			TryAddChar("ĳ', 0133, 673,315,29x45);//14" lsb="-7";
			TryAddChar("Ĵ', 0134, 702,315,31x45);//16" lsb="-7";
			TryAddChar("ĵ', 0135, 733,315,23x45);//8" lsb="-7";
			TryAddChar("Ķ', 0136, 756,315,33x45);//17" lsb="-7";
			TryAddChar("ķ', 0137, 789,315,32x45);//17" lsb="-7";
			TryAddChar("Ĺ', 0139, 821,315,30x45);//15" lsb="-7";
			TryAddChar("ĺ', 013a, 851,315,23x45);//8" lsb="-7";
			TryAddChar("Ļ', 013b, 874,315,30x45);//15" lsb="-7";
			TryAddChar("ļ', 013c, 904,315,23x45);//8" lsb="-7";
			TryAddChar("Ľ', 013d, 927,315,30x45);//15" lsb="-7";
			TryAddChar("ľ', 013e, 957,315,23x45);//8" lsb="-7";
			TryAddChar("Ŀ', 013f, 980,315,30x45);//15" lsb="-7";
			TryAddChar("ŀ', 0140, 0,360,26x45);//10" lsb="-7";
			TryAddChar("Ł', 0141, 26,360,30x45);//15" lsb="-7";
			TryAddChar("ł', 0142, 56,360,23x45);//8" lsb="-7";
			TryAddChar("Ń', 0143, 79,360,37x45);//21" lsb="-7";
			TryAddChar("ń', 0144, 116,360,33x45);//17" lsb="-7";
			TryAddChar("Ņ', 0145, 149,360,37x45);//21" lsb="-7";
			TryAddChar("ņ', 0146, 186,360,33x45);//17" lsb="-7";
			TryAddChar("Ň', 0147, 219,360,37x45);//21" lsb="-7";
			TryAddChar("ň', 0148, 256,360,33x45);//17" lsb="-7";
			TryAddChar("ŉ', 0149, 289,360,33x45);//17" lsb="-7";
			TryAddChar("Ō', 014c, 322,360,37x45);//21" lsb="-7";
			TryAddChar("ō', 014d, 359,360,33x45);//17" lsb="-7";
			TryAddChar("Ŏ', 014e, 392,360,37x45);//21" lsb="-7";
			TryAddChar("ŏ', 014f, 429,360,33x45);//17" lsb="-7";
			TryAddChar("Ő', 0150, 462,360,37x45);//21" lsb="-7";
			TryAddChar("ő', 0151, 499,360,33x45);//17" lsb="-7";
			TryAddChar("Œ', 0152, 532,360,47x45);//31" lsb="-7";
			TryAddChar("œ', 0153, 579,360,44x45);//28" lsb="-7";
			TryAddChar("Ŕ', 0154, 623,360,37x45);//21" lsb="-7";
			TryAddChar("ŕ', 0155, 660,360,25x45);//10" lsb="-7";
			TryAddChar("Ŗ', 0156, 685,360,37x45);//21" lsb="-7";
			TryAddChar("ŗ', 0157, 722,360,25x45);//10" lsb="-7";
			TryAddChar("Ř', 0158, 747,360,37x45);//21" lsb="-7";
			TryAddChar("ř', 0159, 784,360,25x45);//10" lsb="-7";
			TryAddChar("Ś', 015a, 809,360,37x45);//21" lsb="-7";
			TryAddChar("ś', 015b, 846,360,33x45);//17" lsb="-7";
			TryAddChar("Ŝ', 015c, 879,360,37x45);//21" lsb="-7";
			TryAddChar("ŝ', 015d, 916,360,33x45);//17" lsb="-7";
			TryAddChar("Ş', 015e, 949,360,37x45);//21" lsb="-7";
			TryAddChar("ş', 015f, 986,360,33x45);//17" lsb="-7";
			TryAddChar("Š', 0160, 0,405,37x45);//21" lsb="-7";
			TryAddChar("š', 0161, 37,405,33x45);//17" lsb="-7";
			TryAddChar("Ţ', 0162, 70,405,32x45);//17" lsb="-7";
			TryAddChar("ţ', 0163, 102,405,25x45);//9" lsb="-7";
			TryAddChar("Ť', 0164, 127,405,32x45);//17" lsb="-7";
			TryAddChar("ť', 0165, 159,405,25x45);//9" lsb="-7";
			TryAddChar("Ŧ', 0166, 184,405,32x45);//17" lsb="-7";
			TryAddChar("ŧ', 0167, 216,405,25x45);//9" lsb="-7";
			TryAddChar("Ũ', 0168, 241,405,36x45);//20" lsb="-7";
			TryAddChar("ũ', 0169, 277,405,33x45);//17" lsb="-7";
			TryAddChar("Ū', 016a, 310,405,36x45);//20" lsb="-7";
			TryAddChar("ū', 016b, 346,405,33x45);//17" lsb="-7";
			TryAddChar("Ŭ', 016c, 379,405,36x45);//20" lsb="-7";
			TryAddChar("ŭ', 016d, 415,405,33x45);//17" lsb="-7";
			TryAddChar("Ů', 016e, 448,405,36x45);//20" lsb="-7";
			TryAddChar("ů', 016f, 484,405,33x45);//17" lsb="-7";
			TryAddChar("Ű', 0170, 517,405,36x45);//20" lsb="-7";
			TryAddChar("ű', 0171, 553,405,33x45);//17" lsb="-7";
			TryAddChar("Ų', 0172, 586,405,36x45);//20" lsb="-7";
			TryAddChar("ų', 0173, 622,405,33x45);//17" lsb="-7";
			TryAddChar("Ŵ', 0174, 655,405,47x45);//31" lsb="-7";
			TryAddChar("ŵ', 0175, 702,405,42x45);//27" lsb="-7";
			TryAddChar("Ŷ', 0176, 744,405,33x45);//17" lsb="-7";
			TryAddChar("ŷ', 0177, 777,405,33x45);//17" lsb="-7";
			TryAddChar("Ÿ', 0178, 810,405,33x45);//17" lsb="-7";
			TryAddChar("Ź', 0179, 843,405,35x45);//19" lsb="-7";
			TryAddChar("ź', 017a, 878,405,31x45);//16" lsb="-7";
			TryAddChar("Ż', 017b, 909,405,35x45);//19" lsb="-7";
			TryAddChar("ż', 017c, 944,405,31x45);//16" lsb="-7";
			TryAddChar("Ž', 017d, 975,405,35x45);//19" lsb="-7";
			TryAddChar("ž', 017e, 0,450,31x45);//16" lsb="-7";
			TryAddChar("ƒ', 0192, 31,450,35x45);//19" lsb="-7";
			TryAddChar("Ș', 0218, 66,450,37x45);//21" lsb="-7";
			TryAddChar("ș', 0219, 103,450,33x45);//17" lsb="-7";
			TryAddChar("Ț', 021a, 136,450,32x45);//17" lsb="-7";
			TryAddChar("ț', 021b, 168,450,25x45);//9" lsb="-7";
			TryAddChar("ˆ', 02c6, 193,450,23x45);//8" lsb="-7";
			TryAddChar("ˇ', 02c7, 216,450,23x45);//8" lsb="-7";
			TryAddChar("ˉ', 02c9, 239,450,22x45);//6" lsb="-7";
			TryAddChar("˘', 02d8, 261,450,23x45);//8" lsb="-7";
			TryAddChar("˙', 02d9, 284,450,23x45);//8" lsb="-7";
			TryAddChar("˚', 02da, 307,450,23x45);//8" lsb="-7";
			TryAddChar("˛', 02db, 330,450,23x45);//8" lsb="-7";
			TryAddChar("˜', 02dc, 353,450,23x45);//8" lsb="-7";
			TryAddChar("˝', 02dd, 376,450,23x45);//8" lsb="-7";
			TryAddChar("Ё', 0401, 399,450,34x45);//19" lsb="-7";
			TryAddChar("Ѓ', 0403, 433,450,32x45);//16" lsb="-7";
			TryAddChar("Є', 0404, 465,450,34x45);//18" lsb="-7";
			TryAddChar("Ѕ', 0405, 499,450,37x45);//21" lsb="-7";
			TryAddChar("І', 0406, 536,450,24x45);//8" lsb="-7";
			TryAddChar("Ї', 0407, 560,450,24x45);//8" lsb="-7";
			TryAddChar("Ј', 0408, 584,450,31x45);//16" lsb="-7";
			TryAddChar("Љ', 0409, 615,450,43x45);//28" lsb="-7";
			TryAddChar("Њ', 040a, 658,450,37x45);//21" lsb="-7";
			TryAddChar("Ќ', 040c, 695,450,34x45);//19" lsb="-7";
			TryAddChar("Ў', 040e, 729,450,32x45);//17" lsb="-7";
			TryAddChar("Џ', 040f, 761,450,33x45);//18" lsb="-7";
			TryAddChar("А', 0410, 794,450,35x45);//19" lsb="-7";
			TryAddChar("Б', 0411, 829,450,35x45);//19" lsb="-7";
			TryAddChar("В', 0412, 864,450,35x45);//19" lsb="-7";
			TryAddChar("Г', 0413, 899,450,30x45);//15" lsb="-7";
			TryAddChar("Д', 0414, 929,450,35x45);//19" lsb="-7";
			TryAddChar("Е', 0415, 964,450,34x45);//18" lsb="-7";
			TryAddChar("Ж', 0416, 0,495,37x45);//21" lsb="-7";
			TryAddChar("З', 0417, 37,495,33x45);//17" lsb="-7";
			TryAddChar("И', 0418, 70,495,35x45);//19" lsb="-7";
			TryAddChar("Й', 0419, 105,495,34x45);//19" lsb="-7";
			TryAddChar("К', 041a, 139,495,33x45);//17" lsb="-7";
			TryAddChar("Л', 041b, 172,495,33x45);//17" lsb="-7";
			TryAddChar("М', 041c, 205,495,42x45);//26" lsb="-7";
			TryAddChar("Н', 041d, 247,495,33x45);//18" lsb="-7";
			TryAddChar("О', 041e, 280,495,35x45);//20" lsb="-7";
			TryAddChar("П', 041f, 315,495,34x45);//19" lsb="-7";
			TryAddChar("Р', 0420, 349,495,34x45);//19" lsb="-7";
			TryAddChar("С', 0421, 383,495,35x45);//19" lsb="-7";
			TryAddChar("Т', 0422, 418,495,35x45);//19" lsb="-7";
			TryAddChar("У', 0423, 453,495,35x45);//19" lsb="-7";
			TryAddChar("Ф', 0424, 488,495,36x45);//20" lsb="-7";
			TryAddChar("Х', 0425, 524,495,35x45);//19" lsb="-7";
			TryAddChar("Ц', 0426, 559,495,36x45);//20" lsb="-7";
			TryAddChar("Ч', 0427, 595,495,32x45);//16" lsb="-7";
			TryAddChar("Ш', 0428, 627,495,42x45);//26" lsb="-7";
			TryAddChar("Щ', 0429, 669,495,45x45);//29" lsb="-7";
			TryAddChar("Ъ', 042a, 714,495,35x45);//20" lsb="-7";
			TryAddChar("Ы', 042b, 749,495,40x45);//24" lsb="-7";
			TryAddChar("Ь', 042c, 789,495,34x45);//19" lsb="-7";
			TryAddChar("Э', 042d, 823,495,34x45);//18" lsb="-7";
			TryAddChar("Ю', 042e, 857,495,42x45);//27" lsb="-7";
			TryAddChar("Я', 042f, 899,495,35x45);//20" lsb="-7";
			TryAddChar("а', 0430, 934,495,32x45);//16" lsb="-7";
			TryAddChar("б', 0431, 966,495,33x45);//17" lsb="-7";
			TryAddChar("в', 0432, 0,540,31x45);//16" lsb="-7";
			TryAddChar("г', 0433, 31,540,30x45);//15" lsb="-7";
			TryAddChar("д', 0434, 61,540,33x45);//17" lsb="-7";
			TryAddChar("е', 0435, 94,540,33x45);//17" lsb="-7";
			TryAddChar("ж', 0436, 127,540,36x45);//20" lsb="-7";
			TryAddChar("з', 0437, 163,540,30x45);//15" lsb="-7";
			TryAddChar("и', 0438, 193,540,32x45);//16" lsb="-7";
			TryAddChar("й', 0439, 225,540,32x45);//16" lsb="-7";
			TryAddChar("к', 043a, 257,540,32x45);//17" lsb="-7";
			TryAddChar("л', 043b, 289,540,30x45);//15" lsb="-7";
			TryAddChar("м', 043c, 319,540,41x45);//25" lsb="-7";
			TryAddChar("н', 043d, 360,540,31x45);//16" lsb="-7";
			TryAddChar("о', 043e, 391,540,32x45);//16" lsb="-7";
			TryAddChar("п', 043f, 423,540,32x45);//16" lsb="-7";
			TryAddChar("р', 0440, 455,540,32x45);//17" lsb="-7";
			TryAddChar("с', 0441, 487,540,32x45);//16" lsb="-7";
			TryAddChar("т', 0442, 519,540,30x45);//14" lsb="-7";
			TryAddChar("у', 0443, 549,540,33x45);//17" lsb="-7";
			TryAddChar("ф', 0444, 582,540,37x45);//21" lsb="-7";
			TryAddChar("х', 0445, 619,540,31x45);//15" lsb="-7";
			TryAddChar("ц', 0446, 650,540,33x45);//17" lsb="-7";
			TryAddChar("ч', 0447, 683,540,31x45);//15" lsb="-7";
			TryAddChar("ш', 0448, 714,540,41x45);//25" lsb="-7";
			TryAddChar("щ', 0449, 755,540,42x45);//27" lsb="-7";
			TryAddChar("ъ', 044a, 797,540,31x45);//16" lsb="-7";
			TryAddChar("ы', 044b, 828,540,36x45);//20" lsb="-7";
			TryAddChar("ь', 044c, 864,540,31x45);//16" lsb="-7";
			TryAddChar("э', 044d, 895,540,30x45);//14" lsb="-7";
			TryAddChar("ю', 044e, 925,540,39x45);//23" lsb="-7";
			TryAddChar("я', 044f, 964,540,32x45);//17" lsb="-7";
			TryAddChar("ё', 0451, 0,585,33x45);//17" lsb="-7";
			TryAddChar("ђ', 0452, 33,585,33x45);//17" lsb="-7";
			TryAddChar("ѓ', 0453, 66,585,31x45);//16" lsb="-7";
			TryAddChar("є', 0454, 97,585,30x45);//14" lsb="-7";
			TryAddChar("ѕ', 0455, 127,585,32x45);//16" lsb="-7";
			TryAddChar("і', 0456, 159,585,23x45);//8" lsb="-7";
			TryAddChar("ї', 0457, 182,585,23x45);//8" lsb="-7";
			TryAddChar("ј', 0458, 205,585,22x45);//7" lsb="-7";
			TryAddChar("љ', 0459, 227,585,38x45);//22" lsb="-7";
			TryAddChar("њ', 045a, 265,585,41x45);//25" lsb="-7";
			TryAddChar("ћ', 045b, 306,585,33x45);//17" lsb="-7";
			TryAddChar("ќ', 045c, 339,585,31x45);//16" lsb="-7";
			TryAddChar("ў', 045e, 370,585,33x45);//17" lsb="-7";
			TryAddChar("џ', 045f, 403,585,33x45);//17" lsb="-7";
			TryAddChar("Ґ', 0490, 436,585,30x45);//15" lsb="-7";
			TryAddChar("ґ', 0491, 466,585,29x45);//13" lsb="-7";
			TryAddChar("–', 2013, 495,585,30x45);//15" lsb="-7";
			TryAddChar("—', 2014, 525,585,46x45);//31" lsb="-7";
			TryAddChar("‘', 2018, 571,585,22x45);//6" lsb="-7";
			TryAddChar("’', 2019, 593,585,22x45);//6" lsb="-7";
			TryAddChar("‚', 201a, 615,585,22x45);//6" lsb="-7";
			TryAddChar("“', 201c, 637,585,27x45);//12" lsb="-7";
			TryAddChar("”', 201d, 664,585,27x45);//12" lsb="-7";
			TryAddChar("„', 201e, 691,585,27x45);//12" lsb="-7";
			TryAddChar("†', 2020, 718,585,36x45);//20" lsb="-7";
			TryAddChar("‡', 2021, 754,585,36x45);//20" lsb="-7";
			TryAddChar("•', 2022, 790,585,31x45);//15" lsb="-7";
			TryAddChar("…', 2026, 821,585,47x45);//31" lsb="-7";
			TryAddChar("‰', 2030, 868,585,47x45);//31" lsb="-7";
			TryAddChar("‹', 2039, 915,585,24x45);//8" lsb="-7";
			TryAddChar("›', 203a, 939,585,24x45);//8" lsb="-7";
			TryAddChar("€', 20ac, 963,585,35x45);//19" lsb="-7";
			TryAddChar("™', 2122, 0,630,46x45);//30" lsb="-7";
			TryAddChar("−', 2212, 46,630,34x45);//18" lsb="-7";
			TryAddChar("∙', 2219, 80,630,24x45);//8" lsb="-7";
			TryAddChar("□', 25a1, 104,630,37x45);//21" lsb="-7";
			TryAddChar("', e001, 141,630,53x52);//40" lsb="-7" forcewhite="true";
			TryAddChar("', e002, 194,630,53x52);//40" lsb="-7" forcewhite="true";
			TryAddChar("', e003, 247,630,53x52);//40" lsb="-7" forcewhite="true";
			TryAddChar("', e004, 300,630,53x52);//40" lsb="-7" forcewhite="true";
			TryAddChar("', e005, 353,630,53x52);//41" lsb="-7" forcewhite="true";
			TryAddChar("', e006, 406,630,53x52);//41" lsb="-7" forcewhite="true";
			TryAddChar("', e007, 459,630,53x52);//32" lsb="-7" forcewhite="true";
			TryAddChar("', e008, 512,630,53x52);//32" lsb="-7" forcewhite="true";
			TryAddChar("', e009, 565,630,53x52);//40" lsb="-7" forcewhite="true";
			TryAddChar("', e00a, 618,630,53x52);//40" lsb="-7" forcewhite="true";
			TryAddChar("', e00b, 671,630,53x52);//34" lsb="-7" forcewhite="true";
			TryAddChar("', e00c, 724,630,53x52);//34" lsb="-7" forcewhite="true";
			TryAddChar("', e00d, 777,630,53x52);//40" lsb="-7" forcewhite="true";
			TryAddChar("', e00e, 830,630,53x52);//40" lsb="-7" forcewhite="true";
			TryAddChar("', e00f, 883,630,53x52);//40" lsb="-7" forcewhite="true";
			TryAddChar("', e010, 936,630,53x52);//41" lsb="-7" forcewhite="true";
			TryAddChar("', e011, 0,682,53x52);//32" lsb="-7" forcewhite="true";
			TryAddChar("', e012, 53,682,53x52);//41" lsb="-7" forcewhite="true";
			TryAddChar("', e013, 106,682,53x52);//32" lsb="-7" forcewhite="true";
			TryAddChar("', e014, 159,682,53x52);//40" lsb="-7" forcewhite="true";
			TryAddChar("', e015, 212,682,53x52);//40" lsb="-7" forcewhite="true";
			TryAddChar("', e016, 265,682,53x52);//40" lsb="-7" forcewhite="true";
			TryAddChar("', e017, 318,682,53x52);//40" lsb="-7" forcewhite="true";
			TryAddChar("', e018, 371,682,53x52);//40" lsb="-7" forcewhite="true";
			TryAddChar("', e019, 424,682,53x52);//40" lsb="-7" forcewhite="true";
			TryAddChar("', e020, 477,682,53x52);//40" lsb="-7" forcewhite="true";
			TryAddChar("', e021, 530,682,53x52);//40" lsb="-7" forcewhite="true";
			*/
			#endregion
			#endregion
			MyAPIGateway.Multiplayer.RegisterMessageHandler(HUDAPI_MESSAGE, RcvMsg);
			
			MyAPIGateway.Multiplayer.RegisterMessageHandler(HUDAPI_ADVMSG, AdvRcvMsg);
			
			SendHeartBeat();
		}


		#region v2

		enum MessageTypes : int
		{
			HUDMessage = 0,
			BillBoardHUDMessage,
			EntityMessage,
			SpaceMessage
		}

		//Func<int, object> MessageFactory;
		//Action<object, int, object> MessageSetter;
		//Func<object, int, object> MessageGetter;
		//Action<object> RemoveMessage;

		long id = 0;
		private void RemoveMsg(object arg2)
		{
			if(arg2 is ModMessageBase)
			{
				var Msg = (ModMessageBase)arg2;
				Msg.MarkForClose();
			}
		}

		private object GetMember(object arg2, int arg3)
		{
			if(arg2 is ModMessageBase)
			{
				var Msg = (ModMessageBase)arg2;
				return Msg.GetMember(arg3);
			}
			return null;
		}
		private void SetMember(object arg2, int arg3, object arg4)
		{
			if(arg2 is ModMessageBase)
			{
				var Msg = (ModMessageBase)arg2;
				Msg.SetMember(arg3, arg4);
			}
		}
		private object Factory(int arg2)
		{
			ModMessageBase Adder = null;
			switch((MessageTypes)arg2)
			{
				case MessageTypes.HUDMessage:
					Adder = new ModHUDMessage();
					break;
				case MessageTypes.BillBoardHUDMessage:
					Adder = new ModBillboardHUDMessage();
					break;
				case MessageTypes.SpaceMessage:
					Adder = new ModSpaceMessage();
					break;
				case MessageTypes.EntityMessage:
					Adder = new ModEntityMessage();
					break;
			}
			if(Adder != null)
			{
				ModMessageDictionary.GetOrAdd(Adder, 1);
				return Adder;
            }
			return null;
		}

		private void Updatev2()
		{
			foreach (var item in ModMessageDictionary)
			{
				var Msg = item.Key;
				if (Msg.TimeToLive > 0)
					Msg.TimeToLive--;
				if(Msg.TimeToLive == 0)
				{
					Msg.MarkForClose();
				}
				if(Msg.MarkedForClose)
				{
					ModMessageDictionary.TryRemove(item.Key, out id);
				}
				else
				{
					if(Msg.Visible)
						Msg.Draw();
				}
					
			}
		}

		#endregion
		private void AdvRcvMsg(byte[] obj)
		{
			MessageBase msg;
			switch (GetType(obj))
			{
				case -1: return; //fail
				case 1: msg = new SpaceMessage();
					break;
				case 2: msg = new EntityMessage();
					break;
				case 3:
					msg = new AdvHUDMessage();
					break;
				case 4:
					msg = new BillBoardHUDMessage();
					break;
				default:
					return;//fail
			}
			long modid = msg.Decode(obj);
			if (modid == -1)
				return;
			if (!MessageDict.ContainsKey(modid))
			{
				MessageDict.Add(modid, new Dictionary<long, MessageBase>());
			}
			Dictionary<long, MessageBase> ModMessages;
			MessageDict.TryGetValue(modid, out ModMessages);
			if (ModMessages.ContainsKey(msg.id))
			{
				ModMessages.Remove(msg.id);

			}
			ModMessages.Add(msg.id, msg);
		}
		private void Debug(MessageBase msg)
		{

			long modid = 0;
			if (!MessageDict.ContainsKey(modid))
			{
				MessageDict.Add(modid, new Dictionary<long, MessageBase>());
			}
			Dictionary<long, MessageBase> ModMessages;
			MessageDict.TryGetValue(modid, out ModMessages);
			if (ModMessages.ContainsKey(msg.id))
			{
				ModMessages.Remove(msg.id);

			}
			ModMessages.Add(msg.id, msg);
		}

		private int GetType(byte[] obj)
		{
			try
			{
				if (obj.Length > sizeof(short) * 2) 
					return BitConverter.ToUInt16(obj, sizeof(short) * 1);
			}
			catch
			{
				return -1;
			}
			return -1;
		}

		internal void Close()
		{
			MyAPIGateway.Multiplayer.UnregisterMessageHandler(HUDAPI_MESSAGE, RcvMsg);
			MyAPIGateway.Multiplayer.UnregisterMessageHandler(HUDAPI_ADVMSG, AdvRcvMsg);
			foreach(var item in ModMessageDictionary)
			{
				item.Key.MarkForClose();
				item.Key.Close();
			}
			ModMessageDictionary.Clear();
		}

		private void RcvMsg(byte[] obj)
		{

            HUDMessage msg = new HUDMessage();
			long modid = msg.Decode(obj);
			if (modid == -1) return;//fail
			if(!MessageDict.ContainsKey(modid))
			{
				MessageDict.Add(modid, new Dictionary<long, MessageBase>());
			}
			Dictionary<long, MessageBase>  ModMessages;
			MessageDict.TryGetValue(modid, out ModMessages);
			if(ModMessages.ContainsKey(msg.id))
			{
				ModMessages.Remove(msg.id);
				
			}
			ModMessages.Add(msg.id, msg);
		}

		internal void Update()
		{
			heartbeatsend++;
			if(heartbeatsend % 300  == 0)
			{
				heartbeatsend = 0;
				SendHeartBeat();

				MyAPIGateway.Utilities.SendModMessage(REGISTRATIONID, new MyTuple<Func<int, object>, Action<object, int, object>, Func<object, int, object>, Action<object>>(Factory, SetMember, GetMember, RemoveMsg));

			}
			try
			{
				if (MyAPIGateway.Input.IsNewGameControlPressed(MyControlsSpace.TOGGLE_HUD))
					hudHidden = MyAPIGateway.Session?.Config?.MinimalHud ?? false;


				Updatev2();
				foreach (var DictonaryItem in MessageDict)
				{
					long remove = 0;
					foreach (var kvp in DictonaryItem.Value)
					{
						var message = kvp.Value;
						if (message.ttl > 0)
						{
							message.ttl--;
							message.Write();

						}
						else
						{
							remove = kvp.Key;
						}

					}
					if (remove > 0)
					{
						if (DictonaryItem.Value.ContainsKey(remove))
							DictonaryItem.Value.Remove(remove);
					}

				}
			}
			catch
			{

			}


		}

		private void SendHeartBeat()
		{
			byte[] msg = BitConverter.GetBytes(0);
			MyAPIGateway.Multiplayer.SendMessageTo(HUDAPI_RECEIVE, msg, MyAPIGateway.Multiplayer.MyId, true);
		}

		private bool TryAddChar(char v1, int uv1x, int uv1y, int uv2x, int uv2y)
		{
			return TryAddChar(v1, uv1x, uv1y, uv2x, uv2y, "_" + v1);
		}
		private bool TryAddChar(char v1, int uv1x, int uv1y, int uv2x, int uv2y, string material)
		{

			if (FontDict.ContainsKey(v1)) return false;
			FontMatrix mat;
			mat.ox = uv1x;
			mat.oy = uv1y;
			mat.ex = uv2x;
			mat.ey = uv2y;
			mat.material = material;
			FontDict.Add(v1, mat);
            return true;
		}

		public static bool TryGetColor(string word, out Color foundColor)
		{
			foundColor = new Color();
			if(word.Contains(","))
			{
				var colorparam = word.Split(',');
				if (colorparam.Length <= 2) return false;
				int r = 255,g = 255,b= 255,a = 255;
				try
				{

					r = MathHelper.Clamp(Convert.ToInt32(colorparam[0]), 0, 255);
					g = MathHelper.Clamp(Convert.ToInt32(colorparam[1]), 0, 255);
					b = MathHelper.Clamp(Convert.ToInt32(colorparam[2]), 0, 255);
					if (colorparam.Length >= 4)
						a = MathHelper.Clamp(Convert.ToInt32(colorparam[3]), 0, 255);
					foundColor = new Color(r, g, b, a);
					return true;
				}
				catch
				{
					return false;
				}
				
			}
			switch (word.ToLowerInvariant())
			{
				case "aliceblue":
					foundColor = Color.AliceBlue;
					return true;
				case "antiquewhite":
					foundColor = Color.AntiqueWhite;
					return true;
				case "aqua":
					foundColor = Color.Aqua;
					return true;
				case "aquamarine":
					foundColor = Color.Aquamarine;
					return true;
				case "azure":
					foundColor = Color.Azure;
					return true;
				case "beige":
					foundColor = Color.Beige;
					return true;
				case "bisque":
					foundColor = Color.Bisque;
					return true;
				case "black":
					foundColor = Color.Black;
					return true;
				case "blanchedalmond":
					foundColor = Color.BlanchedAlmond;
					return true;
				case "blue":
					foundColor = Color.Blue;
					return true;
				case "blueviolet":
					foundColor = Color.BlueViolet;
					return true;
				case "brown":
					foundColor = Color.Brown;
					return true;
				case "burlywood":
					foundColor = Color.BurlyWood;
					return true;
				case "badetblue":
					foundColor = Color.CadetBlue;
					return true;
				case "chartreuse":
					foundColor = Color.Chartreuse;
					return true;
				case "chocolate":
					foundColor = Color.Chocolate;
					return true;
				case "coral":
					foundColor = Color.Coral;
					return true;
				case "cornflowerblue":
					foundColor = Color.CornflowerBlue;
					return true;
				case "cornsilk":
					foundColor = Color.Cornsilk;
					return true;
				case "crimson":
					foundColor = Color.Crimson;
					return true;
				case "cyan":
					foundColor = Color.Cyan;
					return true;
				case "darkblue":
					foundColor = Color.DarkBlue;
					return true;
				case "darkcyan":
					foundColor = Color.DarkCyan;
					return true;
				case "darkgoldenrod":
					foundColor = Color.DarkGoldenrod;
					return true;
				case "darkgray":
					foundColor = Color.DarkGray;
					return true;
				case "darkgreen":
					foundColor = Color.DarkGreen;
					return true;
				case "darkkhaki":
					foundColor = Color.DarkKhaki;
					return true;
				case "darkmagenta":
					foundColor = Color.DarkMagenta;
					return true;
				case "darkoliveGreen":
					foundColor = Color.DarkOliveGreen;
					return true;
				case "darkorange":
					foundColor = Color.DarkOrange;
					return true;
				case "darkorchid":
					foundColor = Color.DarkOrchid;
					return true;
				case "darkred":
					foundColor = Color.DarkRed;
					return true;
				case "darksalmon":
					foundColor = Color.DarkSalmon;
					return true;
				case "darkseagreen":
					foundColor = Color.DarkSeaGreen;
					return true;
				case "darkslateblue":
					foundColor = Color.DarkSlateBlue;
					return true;
				case "darkslategray":
					foundColor = Color.DarkSlateGray;
					return true;
				case "darkturquoise":
					foundColor = Color.DarkTurquoise;
					return true;
				case "darkviolet":
					foundColor = Color.DarkViolet;
					return true;
				case "deeppink":
					foundColor = Color.DeepPink;
					return true;
				case "deepskyblue":
					foundColor = Color.DeepSkyBlue;
					return true;
				case "dimgray":
					foundColor = Color.DimGray;
					return true;
				case "dodgerblue":
					foundColor = Color.DodgerBlue;
					return true;
				case "firebrick":
					foundColor = Color.Firebrick;
					return true;
				case "floralwhite":
					foundColor = Color.FloralWhite;
					return true;
				case "forestgreen":
					foundColor = Color.ForestGreen;
					return true;
				case "fuchsia":
					foundColor = Color.Fuchsia;
					return true;
				case "gainsboro":
					foundColor = Color.Gainsboro;
					return true;
				case "ghostwhite":
					foundColor = Color.GhostWhite;
					return true;
				case "gold":
					foundColor = Color.Gold;
					return true;
				case "goldenrod":
					foundColor = Color.Goldenrod;
					return true;
				case "gray":
					foundColor = Color.Gray;
					return true;
				case "green":
					foundColor = Color.Green;
					return true;
				case "greenyellow":
					foundColor = Color.GreenYellow;
					return true;
				case "doneydew":
					foundColor = Color.Honeydew;
					return true;
				case "hotpink":
					foundColor = Color.HotPink;
					return true;
				case "indianred":
					foundColor = Color.IndianRed;
					return true;
				case "indigo":
					foundColor = Color.Indigo;
					return true;
				case "ivory":
					foundColor = Color.Ivory;
					return true;
				case "khaki":
					foundColor = Color.Khaki;
					return true;
				case "lavender":
					foundColor = Color.Lavender;
					return true;
				case "lavenderblush":
					foundColor = Color.LavenderBlush;
					return true;
				case "lawngreen":
					foundColor = Color.LawnGreen;
					return true;
				case "lemonchiffon":
					foundColor = Color.LemonChiffon;
					return true;
				case "lightblue":
					foundColor = Color.LightBlue;
					return true;
				case "lightcoral":
					foundColor = Color.LightCoral;
					return true;
				case "lightcyan":
					foundColor = Color.LightCyan;
					return true;
				case "lightgoldenrodyellow":
					foundColor = Color.LightGoldenrodYellow;
					return true;
				case "lightgray":
					foundColor = Color.LightGray;
					return true;
				case "lightgreen":
					foundColor = Color.LightGreen;
					return true;
				case "lightpink":
					foundColor = Color.LightPink;
					return true;
				case "lightsalmon":
					foundColor = Color.LightSalmon;
					return true;
				case "lightseagreen":
					foundColor = Color.LightSeaGreen;
					return true;
				case "lightskyblue":
					foundColor = Color.LightSkyBlue;
					return true;
				case "lightslategray":
					foundColor = Color.LightSlateGray;
					return true;
				case "lightsteelblue":
					foundColor = Color.LightSteelBlue;
					return true;
				case "lightyellow":
					foundColor = Color.LightYellow;
					return true;
				case "lime":
					foundColor = Color.Lime;
					return true;
				case "limegreen":
					foundColor = Color.LimeGreen;
					return true;
				case "linen":
					foundColor = Color.Linen;
					return true;
				case "magenta":
					foundColor = Color.Magenta;
					return true;
				case "maroon":
					foundColor = Color.Maroon;
					return true;
				case "mediumaquamarine":
					foundColor = Color.MediumAquamarine;
					return true;
				case "mediumblue":
					foundColor = Color.MediumBlue;
					return true;
				case "mediumorchid":
					foundColor = Color.MediumOrchid;
					return true;
				case "mediumpurple":
					foundColor = Color.MediumPurple;
					return true;
				case "mediumseagreen":
					foundColor = Color.MediumSeaGreen;
					return true;
				case "mediumslateblue":
					foundColor = Color.MediumSlateBlue;
					return true;
				case "mediumspringgreen":
					foundColor = Color.MediumSpringGreen;
					return true;
				case "mediumturquoise":
					foundColor = Color.MediumTurquoise;
					return true;
				case "mediumvioletred":
					foundColor = Color.MediumVioletRed;
					return true;
				case "midnightblue":
					foundColor = Color.MidnightBlue;
					return true;
				case "mintcream":
					foundColor = Color.MintCream;
					return true;
				case "mistyrose":
					foundColor = Color.MistyRose;
					return true;
				case "moccasin":
					foundColor = Color.Moccasin;
					return true;
				case "navajowhite":
					foundColor = Color.NavajoWhite;
					return true;
				case "navy":
					foundColor = Color.Navy;
					return true;
				case "oldlace":
					foundColor = Color.OldLace;
					return true;
				case "olive":
					foundColor = Color.Olive;
					return true;
				case "olivedrab":
					foundColor = Color.OliveDrab;
					return true;
				case "orange":
					foundColor = Color.Orange;
					return true;
				case "orangered":
					foundColor = Color.OrangeRed;
					return true;
				case "orchid":
					foundColor = Color.Orchid;
					return true;
				case "palegoldenrod":
					foundColor = Color.PaleGoldenrod;
					return true;
				case "palegreen":
					foundColor = Color.PaleGreen;
					return true;
				case "paleturquoise":
					foundColor = Color.PaleTurquoise;
					return true;
				case "palevioletred":
					foundColor = Color.PaleVioletRed;
					return true;
				case "papayawhip":
					foundColor = Color.PapayaWhip;
					return true;
				case "peachpuff":
					foundColor = Color.PeachPuff;
					return true;
				case "peru":
					foundColor = Color.Peru;
					return true;
				case "pink":
					foundColor = Color.Pink;
					return true;
				case "plum":
					foundColor = Color.Plum;
					return true;
				case "powderblue":
					foundColor = Color.PowderBlue;
					return true;
				case "purple":
					foundColor = Color.Purple;
					return true;
				case "red":
					foundColor = Color.Red;
					return true;
				case "rosybrown":
					foundColor = Color.RosyBrown;
					return true;
				case "royalblue":
					foundColor = Color.RoyalBlue;
					return true;
				case "saddlebrown":
					foundColor = Color.SaddleBrown;
					return true;
				case "salmon":
					foundColor = Color.Salmon;
					return true;
				case "sandybrown":
					foundColor = Color.SandyBrown;
					return true;
				case "seagreen":
					foundColor = Color.SeaGreen;
					return true;
				case "seashell":
					foundColor = Color.SeaShell;
					return true;
				case "sienna":
					foundColor = Color.Sienna;
					return true;
				case "silver":
					foundColor = Color.Silver;
					return true;
				case "skyblue":
					foundColor = Color.SkyBlue;
					return true;
				case "slateblue":
					foundColor = Color.SlateBlue;
					return true;
				case "slategray":
					foundColor = Color.SlateGray;
					return true;
				case "snow":
					foundColor = Color.Snow;
					return true;
				case "springgreen":
					foundColor = Color.SpringGreen;
					return true;
				case "steelblue":
					foundColor = Color.SteelBlue;
					return true;
				case "tan":
					foundColor = Color.Tan;
					return true;
				case "teal":
					foundColor = Color.Teal;
					return true;
				case "thistle":
					foundColor = Color.Thistle;
					return true;
				case "tomato":
					foundColor = Color.Tomato;
					return true;
				case "turquoise":
					foundColor = Color.Turquoise;
					return true;
				case "violet":
					foundColor = Color.Violet;
					return true;
				case "wheat":
					foundColor = Color.Wheat;
					return true;
				case "white":
					foundColor = Color.White;
					return true;
				case "whitesmoke":
					foundColor = Color.WhiteSmoke;
					return true;
				case "yellow":
					foundColor = Color.Yellow;
					return true;
				case "yellowgreen":
					foundColor = Color.YellowGreen;
					return true;
			}

			return false;
		}

	}
}
