﻿using Sandbox.ModAPI;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using VRage.Game;
using VRage.Utils;
using VRageMath;
using BlendTypeEnum = VRageRender.MyBillboard.BlendTypeEnum;

namespace UIFun
{
	static class VersionHelper
	{
		static int m_AppVersion = 0;
		static int AppVersion
		{
			get
			{
				if (m_AppVersion > 0)
					return m_AppVersion;
				if(MyAPIGateway.Session?.GetWorld()?.Checkpoint?.AppVersion != null)
				{
					m_AppVersion = MyAPIGateway.Session.GetWorld().Checkpoint.AppVersion;
                }
				return m_AppVersion;
			}

		}
	
		internal static void AddBillboardOriented(MyStringId v1, Vector4 fontcolor, Vector3D textpos, Vector3D up, Vector3D left, float v2, BlendTypeEnum blend = BlendTypeEnum.Standard)
		{
			//MyTransparentGeometry.AddBillboardOriented(v1, fontcolor, textpos, left, up, v2);
			MyTransparentGeometry.AddBillboardOriented(v1, fontcolor, textpos, left, up, v2, blend);
			
		}
		internal static void AddBillboardOriented(MyStringId v1, Vector4 fontcolor, Vector3D textpos, Vector3D up, Vector3D left, float width, float height, BlendTypeEnum blend = BlendTypeEnum.Standard)
		{
			//MyTransparentGeometry.AddBillboardOriented(v1, fontcolor, textpos, left, up, width, height);
			
			MyTransparentGeometry.AddBillboardOriented(v1, fontcolor, textpos, left, up, width, height, Vector2.Zero, blend);
		}

	}
}
